Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.tree
Class ElementWithAttributes

    java.lang.Object
      net.sf.saxon.tree.NodeImpl
          net.sf.saxon.tree.ParentNodeImpl
              net.sf.saxon.tree.ElementImpl
                  net.sf.saxon.tree.ElementWithAttributes

All Implemented Interfaces:
  FingerprintedNode, Item, NodeInfo, javax.xml.transform.Source, javax.xml.transform.SourceLocator, ValueRepresentation

Direct Known Subclasses:
  DataElement, SchemaElement, StyleElement

public class ElementWithAttributes
extends ElementImpl

A node in the XML parse tree representing an XML element.

This class is an implementation of NodeInfo

Field Summary
`protected AttributeCollection` | `attributeList`
`protected int[]` | `namespaceList`

Fields inherited from class net.sf.saxon.tree.ElementImpl
`nameCode, root, sequence`

Fields inherited from class net.sf.saxon.tree.NodeImpl
`index, NODE_LETTER, parent`

Fields inherited from interface net.sf.saxon.om.NodeInfo
`ALL_NAMESPACES, EMPTY_NAMESPACE_LIST, IS_DTD_TYPE, LOCAL_NAMESPACES, NO_NAMESPACES`

Fields inherited from interface net.sf.saxon.om.ValueRepresentation
`EMPTY_VALUE_ARRAY`

Constructor Summary
`ElementWithAttributes()`

Method Summary
`void` | `copy(Receiver out, int whichNamespaces, boolean copyAnnotations, int locationId)` Copy this node to a given outputter (supporting xsl:copy-of)
`AttributeCollection` | `getAttributeList()` Get the attribute list for this element.
`java.lang.String` | `getAttributeValue(int fingerprint)` Get the value of a given attribute of this node
`int[]` | `getDeclaredNamespaces(int[] buffer)` Get all namespace undeclarations and undeclarations defined on this element.
`int[]` | `getInScopeNamespaceCodes()` Get the list of in-scope namespaces for this element as an array of namespace codes.
`java.lang.String` | `getPrefixForURI(java.lang.String uri)` Search the NamespaceList for a given URI, returning the corresponding prefix.
`short` | `getURICodeForPrefix(java.lang.String prefix)` Search the NamespaceList for a given prefix, returning the corresponding URI.
`java.lang.String` | `getURIForPrefix(java.lang.String prefix, boolean useDefault)` Get the namespace URI corresponding to a given prefix.
`void` | `initialise(int nameCode, AttributeCollectionImpl atts, NodeInfo parent, java.lang.String baseURI, int lineNumber, int sequenceNumber)` Initialise a new ElementWithAttributes with an element name and attribute list
`java.util.Iterator` | `iteratePrefixes()` Get an iterator over all the prefixes declared in this namespace context.
`void` | `sendNamespaceDeclarations(Receiver out, boolean includeAncestors)` Output all namespace nodes associated with this element.
`void` | `setNamespaceDeclarations(int[] namespaces, int namespacesUsed)` Set the namespace declarations for the element

Methods inherited from class net.sf.saxon.tree.ElementImpl
`addChild, compact, enumerateChildren, generateId, getBaseURI, getDocumentRoot, getFirstChild, getLastChild, getLineNumber, getNameCode, getNodeKind, getNthChild, getRoot, getSequenceNumber, getStringValue, getStringValueCS, getSystemId, hasChildNodes, setLineNumber, setNameCode, setSystemId, useChildrenArray`

Methods inherited from class net.sf.saxon.tree.NodeImpl
`atomize, compareOrder, equals, getColumnNumber, getConfiguration, getDisplayName, getDocumentNumber, getFingerprint, getLocalPart, getNamePool, getNextInDocument, getNextSibling, getParent, getPrefix, getPreviousInDocument, getPreviousSibling, getPublicId, getTypeAnnotation, getTypedValue, getURI, hashCode, isSameNodeInfo, iterateAxis, iterateAxis`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### attributeList

    protected AttributeCollection attributeList

### namespaceList

    protected int[] namespaceList

Constructor Detail

### ElementWithAttributes

    public ElementWithAttributes()

Method Detail

### initialise

    public void initialise(int nameCode,
                           AttributeCollectionImpl atts,
                           NodeInfo parent,
                           java.lang.String baseURI,
                           int lineNumber,
                           int sequenceNumber)

  Initialise a new ElementWithAttributes with an element name and attribute list

  Overrides:
    `initialise` in class `ElementImpl`
  Parameters:
    `nameCode` - The element name, with namespaces resolved
    `atts` - The attribute list, after namespace processing
    `parent` - The parent node
    `baseURI` - The base URI of the new element
    `lineNumber` - The line number of the element in the source document
    `sequenceNumber` - Integer identifying this element within the document

### setNamespaceDeclarations

    public void setNamespaceDeclarations(int[] namespaces,
                                         int namespacesUsed)

  Set the namespace declarations for the element

### getURIForPrefix

    public java.lang.String getURIForPrefix(java.lang.String prefix,
                                            boolean useDefault)

  Get the namespace URI corresponding to a given prefix. Return null if the prefix is not in scope.

  Parameters:
    `prefix` - the namespace prefix. May be the zero-length string, indicating that there is no prefix. This indicates either the default namespace or the null namespace, depending on the value of useDefault.
    `useDefault` - true if the default namespace is to be used when the prefix is "". If false, the method returns "" when the prefix is "".
  Returns:
    the uri for the namespace, or null if the prefix is not in scope. The "null namespace" is represented by the pseudo-URI "".

### iteratePrefixes

    public java.util.Iterator iteratePrefixes()

  Get an iterator over all the prefixes declared in this namespace context. This will include the default namespace (prefix="") and the XML namespace where appropriate

### getURICodeForPrefix

    public short getURICodeForPrefix(java.lang.String prefix)
                              throws NamespaceException

  Search the NamespaceList for a given prefix, returning the corresponding URI.

  Parameters:
    `prefix` - The prefix to be matched. To find the default namespace, supply ""
  Returns:
    The URI code corresponding to this namespace. If it is an unnamed default namespace, return Namespace.NULL_CODE.
  Throws:
    `NamespaceException` - if the prefix has not been declared on this NamespaceList.

### getPrefixForURI

    public java.lang.String getPrefixForURI(java.lang.String uri)

  Search the NamespaceList for a given URI, returning the corresponding prefix.

  Parameters:
    `uri` - The URI to be matched.
  Returns:
    The prefix corresponding to this URI. If not found, return null. If there is more than one prefix matching the URI, the first one found is returned. If the URI matches the default namespace, return an empty string.

### sendNamespaceDeclarations

    public void sendNamespaceDeclarations(Receiver out,
                                          boolean includeAncestors)
                                   throws XPathException

  Output all namespace nodes associated with this element.

  Specified by:
    `sendNamespaceDeclarations` in interface `NodeInfo`
  Overrides:
    `sendNamespaceDeclarations` in class `ElementImpl`
  Parameters:
    `out` - The relevant outputter
  Throws:
    `XPathException`

### getDeclaredNamespaces

    public int[] getDeclaredNamespaces(int[] buffer)

  Get all namespace undeclarations and undeclarations defined on this element.

  Specified by:
    `getDeclaredNamespaces` in interface `NodeInfo`
  Overrides:
    `getDeclaredNamespaces` in class `ElementImpl`
  Parameters:
    `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
  Returns:
    An array of integers representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. Otherwise, the returned array is a sequence of namespace codes, whose meaning may be interpreted by reference to the name pool. The top half word of each namespace code represents the prefix, the bottom half represents the URI. If the bottom half is zero, then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to -1.

    For a node other than an element, the method returns null.

### getInScopeNamespaceCodes

    public int[] getInScopeNamespaceCodes()

  Get the list of in-scope namespaces for this element as an array of namespace codes. (Used by LiteralResultElement)

### getAttributeList

    public AttributeCollection getAttributeList()

  Get the attribute list for this element.

  Overrides:
    `getAttributeList` in class `ElementImpl`
  Returns:
    The attribute list. This will not include any namespace attributes. The attribute names will be in expanded form, with prefixes replaced by URIs

### getAttributeValue

    public java.lang.String getAttributeValue(int fingerprint)

  Get the value of a given attribute of this node

  Specified by:
    `getAttributeValue` in interface `NodeInfo`
  Overrides:
    `getAttributeValue` in class `NodeImpl`
  Parameters:
    `fingerprint` - The fingerprint of the attribute name
  Returns:
    the attribute value if it exists or null if not

### copy

    public void copy(Receiver out,
                     int whichNamespaces,
                     boolean copyAnnotations,
                     int locationId)
              throws XPathException

  Copy this node to a given outputter (supporting xsl:copy-of)

  Specified by:
    `copy` in interface `NodeInfo`
  Overrides:
    `copy` in class `ElementImpl`
  Parameters:
    `out` - The outputter
    `whichNamespaces` - indicates which namespaces should be output: all, none, or local namespaces only (those not declared on the parent element)
  Throws:
    `XPathException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD